<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="队伍" prop="ranks">
        <el-select v-model="queryParams.ranks" clearable placeholder="请选择" @change="getUsers" :disabled="postName.indexOf('xx') > -1&&postName!='xxallrank'">
          <el-option
            v-for="item in postOptions"
            :key="item.postId"
            :label="item.postName"
            :value="item.postId"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="负责人" prop="userId">
        <el-select v-model="queryParams.userId" filterable placeholder="请选择负责人" clearable size="small">
          <el-option v-for="item in workerListSelect"
                     :key="item.id"
                     :label="item.name"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="行政区" prop="district">
        <el-select v-model="queryParams.district" placeholder="请选择行政区" clearable size="small">
          <el-option
            v-for="dict in dict.type.district"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="小区名" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入小区名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['gas:area:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['gas:area:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['gas:area:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-hasPermi="['system:user:import']"
        >导入小区
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['gas:area:export']"
        >导出
        </el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="success"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          :loading="exportLoading"-->
<!--          @click="handleInstall"-->
<!--          v-hasPermi="['gas:courtyardNetworkManagement:export']"-->
<!--        >下载-->
<!--        </el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="areaList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="主键id" align="center" prop="id" v-if="false"/>
      <el-table-column label="序列" width="70">
        <template slot-scope="scope">
          {{(queryParams.pageNum-1)*queryParams.pageSize+scope.$index+1}}
        </template>
      </el-table-column>
      <el-table-column label="小区名" align="center" prop="name"/>
<!--      <el-table-column label="负责人" align="center" prop="userName">-->
        <!--        <template slot-scope="scope">-->
        <!--          {{ getUserName(scope.row.userId) }}-->
        <!--        </template>-->
<!--      </el-table-column>-->
      <!--      <el-table-column label="是否释放" align="center" prop="releaseIs">-->
      <!--        <template slot-scope="scope">-->
      <!--          <dict-tag :options="dict.type.release_status" :value="scope.row.releaseIs"/>-->
      <!--        </template>-->
      <!--      </el-table-column>-->
      <!--      <el-table-column label="释放人" align="center" prop="releaseBy"/>-->
      <el-table-column label="行政区" align="center" prop="district">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.district" :value="scope.row.district"/>
        </template>
      </el-table-column>
      <el-table-column label="小区规模" align="center" prop="areaSize"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['gas:area:edit']"
          >修改
          </el-button>
          <!--          <el-button-->
          <!--            size="mini"-->
          <!--            type="text"-->
          <!--            icon="el-icon-edit"-->
          <!--            @click="handleRelease(scope.row)"-->
          <!--            v-hasPermi="['gas:area:edit']"-->
          <!--          >释放-->
          <!--          </el-button>-->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['gas:area:remove']"
          >删除
          </el-button>
          <el-button
            type="text"
            size="mini"
             icon="el-icon-download"
            :loading="exportLoading"
            @click="handleInstall(scope.row)"
            v-hasPermi="['gas:courtyardNetworkManagement:export']"
          >下载
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <!--<div class="el-upload__tip" slot="tip">-->
          <!--<el-checkbox v-model="upload.updateSupport"/>-->
          <!--是否更新已经存在的用户数据-->
          <!--</div>-->
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link type="primary" :underline="false" style="font-size:12px;vertical-align: baseline;"
                   @click="importTemplate"
          >下载模板
          </el-link>
        </div>
      </el-upload>
      <div style="padding-top: 15px;line-height: 25px;font-size: 14px;">
        完成度：{{ bfb }}%
        <progress max="100" :value="bfb" style="width: 200px;height: 18px;"></progress>
        <br>
        导入结果：{{ jdtMsg }}
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false;bfb='0';jdtMsg=''">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 添加或修改小区对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="小区名" prop="name">
          <el-input v-model="form.name" placeholder="请输入小区名"/>
        </el-form-item>
<!--        <el-form-item label="负责人" prop="userIds">-->
<!--          <el-select v-model="userIds" multiple filterable placeholder="请选择负责人" style="width: 100%">-->
<!--            <el-option v-for="(item,index) in workerList"-->
<!--                       :key="index"-->
<!--                       :label="item.name"-->
<!--                       :value="item.id"/>-->
<!--          </el-select>-->
<!--        </el-form-item>-->
        <el-form-item label="行政区" prop="district">
          <el-select v-model="form.district" placeholder="请选择行政区" style="width: 100%">
            <el-option
              v-for="dict in dict.type.district"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="小区规模" prop="areaSize">
          <el-input-number v-model="form.areaSize" :min="1" label="请输入小区规模" style="width: 100%"/>
        </el-form-item>
<!--        <el-form-item label="照片" prop="photoList">-->
<!--          <imageUpload v-model="form.photoList"/>-->
<!--        </el-form-item>-->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listArea,
  getArea,
  delArea,
  addArea,
  updateArea,
  releaseIs,
  flushProgress,
  clearFlushProgress
} from "@/api/gas/area";
import {getWorker} from "@/api/gas/user";
import {getToken} from "@/utils/auth";
import {listPostAll} from "@/api/system/post";
import Cookies from "js-cookie";

export default {
  name: "Area",
  dicts: ['release_status', 'district','install_type'],
  data() {
    return {
      //进度条
      timeInterval: null,
      bfb: '0',
      jdtMsg: '',
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: '',
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: 'Bearer ' + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + '/gas/area/importData'
      },
      // 按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      userIds: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 小区表格数据
      areaList: [],
      // 岗位选项
      postOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,

      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: undefined,
        userId: undefined,
        district: undefined,
        ranks: (Cookies.get("postName").indexOf('xx') > -1 ? parseInt(Cookies.get("postId")) : undefined),
      },
      postName: Cookies.get("postName"),
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          {required: true, message: "小区名不能为空", trigger: "blur"}
        ],
        // userIds: [
        //   {required: false, message: "负责人不能为空", trigger: "change"}
        // ],
        releaseIs: [
          {required: true, message: "是否释放不能为空", trigger: "change"}
        ],
        district: [
          {required: true, message: "行政区不能为空", trigger: "change"}
        ],
      },
      workerListSelect: [],
      workerList: [],
      installList:[],
      value:'庭院网管'
    };
  },
  created() {
    // this.getWorkerList();
    this.getList();
    this.getdictList();
    this.getPostList();
  },
  mounted() {
    setTimeout(
      this.getUsers(parseInt(Cookies.get("postId")))
      ,1000)
  },
  methods: {
    getUsers(value){
      if (!value) return;
      getWorker({ranks:value}).then(response => {
        this.workerListSelect = response.data;
      });
    },
    //获取岗位列
    getPostList(){
      listPostAll({remark:'ranks'}).then(response => {
        this.postOptions = response.data;
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.isUploading = false
      this.$refs.upload.clearFiles()
      this.getList()
    },
    /** 下载模板操作 */
    importTemplate() {
      this.$download.excel('/gas/area/importTemplate')
    },
    // 提交上传文件
    submitFileForm() {
      const ther = this
      this.timeInterval = setInterval(function() {
        ther.flushProgress()
      }, 1500)
      this.$refs.upload.submit()
    },
    // 提交上传文件
    flushProgress() {
      flushProgress().then(response => {
        this.bfb = parseInt(response.data.bfb) >= 100 ? 100 : response.data.bfb
        this.jdtMsg = response.data.message
        if (response.data.message != null && response.data.message != '') {
          clearFlushProgress().then(response => {
          })
          clearInterval(this.timeInterval)
        }
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = '用户导入'
      this.upload.open = true
    },
    //释放
    handleRelease(row) {
      this.$modal.confirm('请确认照片是否下载！释放过程不可逆！是否释放？').then(() => {
        this.loading = true
        return releaseIs(row.id)
      }).then(() => {
        this.loading = false
        this.getList()
        this.getArea()
        this.$modal.msgSuccess('释放成功')
      }).finally(() => {
        this.loading = false
      })
    },
    getUserName(userId) {
      let name = ''
      if (userId == undefined || userId == null || userId == '') {
        return ''
      }
      for (let i = 0; i < userId.split(",").length; i++) {
        if (i === 0) name = this.workerList.filter(item => item.id == userId.split(",")[i])[0].name
        else name = name + "," + this.workerList.filter(item => item.id == userId.split(",")[i])[0].name
      }
      return name
    },
    getWorkerList(ranks) {
      let data = null
      if(ranks){
        data = {
          ranks:ranks
        }
      }
      getWorker(data).then(req => {
        this.workerList = req.data
      })
    },
    /** 查询小区列表 */
    getList() {
      this.loading = true;
      if (this.queryParams.userId == '') {
        this.queryParams.userId = undefined
      }
      if (this.queryParams.userId != undefined)
        this.queryParams.userId = this.queryParams.userId + ""
      listArea(this.queryParams).then(response => {
        this.areaList = []
        this.areaList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
      if (this.queryParams.userId != undefined)
        this.queryParams.userId = this.queryParams.userId * 1
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.userIds = []
      this.form = {
        id: undefined,
        name: undefined,
        userId: undefined,
        userIds: [],
        releaseIs: undefined,
        releaseBy: undefined,
        district: undefined,
        calculateDistrictId: undefined,
        areaSize: 1,
        affiliatedPackage: undefined,
        delFlag: undefined,
        createBy: undefined,
        createTime: undefined,
        updateBy: undefined,
        updateTime: undefined,
        photoList: ""
      };
      this.resetForm("form");
    },
    getdictList() {
      this.getDicts("install_type").then(response => {
        this.installList = response.data;
        console.log(this.installList)
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.workerListSelect=[]
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加小区";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.reset();
      const id = row.id || this.ids
      getArea(id).then(response => {
        this.loading = false;
        this.form = response.data;
        // this.userIds = response.data.userId == '' || response.data.userId == null ? [] : response.data.userId.split(",").map(Number);
        this.form.userId = response.data.userId;
        this.open = true;
        this.title = "修改小区";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          // this.form.userId = this.userIds.join(",")
          if (this.form.releaseIs === 'Y') {
            this.form.releaseBy = this.$store.state.user.userId
          }
          if (this.form.id != null) {
            if (typeof this.form.photoList === 'string') {
              this.form.photoList = this.form.photoList.split(',')
            }
            updateArea(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            this.form.photoList = this.form.photoList.split(',')
            addArea(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除小区编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delArea(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.$download.excel('/gas/area/export', this.queryParams);
    },
    handleInstall(data) {
      const h = this.$createElement;
      const that = this
      this.$msgbox({
        title: '消息',
        message: h('p', null, [
          h('span', null, '选择下载类型 '),
          h('el-select', {
              props: {
                value: that.value,
                filterable: true,
              },
              ref: 'selectView',
              on: {
                change:e => {
                  that.value = e
                  that.$refs.selectView.value = e  // select下拉框值改变，回显到页面上
                },
              },
            },
            [
              that.installList.map(it => {
                return h('el-option', {
                  props: {
                    label: it.dictLabel,
                    key: it.dictLabel,
                    value: it.dictLabel,
                  },
                });
              })
            ]
          )
        ]),
        showCancelButton: true,
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        beforeClose: (action, instance, done) => {
          console.log(this.value)
          let obj=that.installList.filter(item=>item.dictLabel==this.value)
          console.log(obj)
          if (action === 'confirm') {
            instance.confirmButtonLoading = true;
            instance.confirmButtonText = '执行中...';
            this.$download.zip(`/gas/courtyardNetworkManagement/install?id=${data.id}&findProblem=${this.value}&remarks=${obj[0].dictValue}`, data.name+this.value);
            setTimeout(() => {
              done();
              setTimeout(() => {
                instance.confirmButtonLoading = false;
              }, 300);
            }, 3000);
          } else {
            done();
          }
        }
      }).then(action => {

      });


    }
  }
};
</script>
